clear all

load aCGH_Pollack_chr17

D(isnan(D)) = 0;
[m,n] = size(D);

% normalize
for i = 1:n
    l = round(m/4);
    d = medfilt1(D(:,i),l);
    D(:,i) = D(:,i) - d;
end

 % estimate sigma
d = D(abs(D)<2);
sig = 1.48*median(abs(d(:)-median(d(:))));

% Run PLA
alpha1 = sqrt(m)*sig;
alpha2 = 0.01*alpha1;
beta = 2*sig;
tol = 1e-4;

tic;
[B,E] = RPLA(D,alpha1,alpha2,beta,tol);
t_pla = toc;


figure;
subplot(4,1,1);
imagesc(D',[-1,1]); 
title('Input matrix'); 
ylabel('Sample Index');
subplot(4,1,2);
imagesc(B',[-1,1]); 
title('Low-rank component'); 
ylabel('Sample Index');
subplot(4,1,3);
imagesc(E',[-1,1]); 
title('Sparse component'); 
ylabel('Sample Index');
subplot(4,1,4);
Th = 0.225;
gain = sum(B>Th,2);
loss = sum(B<-Th,2);
hold on;
bar(gain/n,'r','EdgeColor','none'); 
bar(-loss/n,'b','EdgeColor','none');
ylabel('Frequency');
title('Fraction of alternations'); 